import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { MerchantPackageGoods, MerchantPackageGoodsParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商家套餐可使用的商品
 */
export async function pageMerchantPackageGoods(params: MerchantPackageGoodsParam) {
  const res = await request.get<ApiResult<PageResult<MerchantPackageGoods>>>(
    MODULES_API_URL + '/shop/merchant-package-goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商家套餐可使用的商品列表
 */
export async function listMerchantPackageGoods(params?: MerchantPackageGoodsParam) {
  const res = await request.get<ApiResult<MerchantPackageGoods[]>>(
    MODULES_API_URL + '/shop/merchant-package-goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商家套餐可使用的商品
 */
export async function addMerchantPackageGoods(data: MerchantPackageGoods) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-package-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商家套餐可使用的商品
 */
export async function updateMerchantPackageGoods(data: MerchantPackageGoods) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-package-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商家套餐可使用的商品
 */
export async function removeMerchantPackageGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-package-goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商家套餐可使用的商品
 */
export async function removeBatchMerchantPackageGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-package-goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商家套餐可使用的商品
 */
export async function getMerchantPackageGoods(id: number) {
  const res = await request.get<ApiResult<MerchantPackageGoods>>(
    MODULES_API_URL + '/shop/merchant-package-goods/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
